jQuery(document).ready(function() {

    jQuery('body').on('updated_checkout', function(){
        request_a_date_403_check_ship();
    });

    request_a_date_403_check_ship();    
});

function request_a_date_403_check_ship() {
    var data = {
            action : 'request_a_date_403_check_ship'
        };

    jQuery.ajax({
        url      : request_a_date_403_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                jQuery('#request_a_date_block').show();
            } else {
                jQuery('#request_a_date_block').hide();
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function request_a_date_403_show_date_init() {
    var date = jQuery('#request_a_date').val()
    request_a_date_403_show_date_select(date)
}

function request_a_date_403_show_month(date) {
    jQuery('#request_a_date_calendar_select').remove();
    request_a_date_403_show_date_select(date);    
}

function request_a_date_403_show_date_select(date) {
    jQuery('#request_a_date_calendar').find('.dashicons').removeClass('dashicons-calendar-alt');
    jQuery('#request_a_date_calendar').find('.dashicons').addClass('dashicons-update-alt');
    jQuery('#request_a_date_calendar').find('.dashicons').addClass('spin');
    var data = {
            action : 'request_a_date_403_show_date_select',
            date   : date
        };

    jQuery.ajax({
        url      : request_a_date_403_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery(data.html).insertBefore('#request_a_date_calendar');

                jQuery('#request_a_date_calendar').find('.dashicons').removeClass('spin');
                jQuery('#request_a_date_calendar').find('.dashicons').removeClass('dashicons-update-alt');
                jQuery('#request_a_date_calendar').find('.dashicons').addClass('dashicons-calendar-alt');

                jQuery(document).on('click', function (e) {
                    if (jQuery(e.target).closest('#request_a_date_calendar_select').length === 0) {
                        jQuery('#request_a_date_calendar_select').remove();
                    }
                });

                jQuery('#request_a_date_calendar_select').find('.optional').on('click', function (e) {
                    var date = jQuery(this).attr('data-date');
                    request_a_date_403_save_date(date);
                });
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function request_a_date_403_save_date(date) {

    jQuery('#request_a_date').val(date);
    jQuery('#request_a_date_calendar_select').remove();
    jQuery('.request-a-date-info').val(request_a_date_updating_text);
    
    var data = {
            action : 'request_a_date_403_get_formatted_date',
            date   : date
        };

    jQuery.ajax({
        url      : request_a_date_403_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            jQuery('.request-a-date-info').val(data.html);
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}
