<?php

function request_a_date_403_get_first_day() {
    $options = request_a_date_403_get_options();

    $date = date_i18n('Y-m-d');
    if (date_i18n('H:i') > $options['intime']) {
        $date = date_i18n('Y-m-d', strtotime('+1 day', strtotime($date)));
    }   
    if (!empty($options['shift']) and ($options['shift'] != '0')) {
        $date = date_i18n('Y-m-d', strtotime('+'.$options['shift'].' day', strtotime($date)));
    }

    $add = 0;
    $items = WC()->cart->get_cart();
    foreach ($items as $item) {
        $product = wc_get_product($item['product_id']);
        $stock = $product->get_stock_quantity();
        if (!empty($stock)) {
            if ($item['quantity'] >= $stock) {
                $add = $options['reorder'];
            }
        }
    }

    if (has_filter('request_a_date_add_custom_days')) {
        $add = apply_filters('request_a_date_add_custom_days', $add);
    }

    if ($add > 0) {
        $date = date_i18n('Y-m-d', strtotime('+'.$add.' day', strtotime($date)));
    }

    if (has_filter('request_a_date_modify_first')) {
        $date = apply_filters('request_a_date_modify_first', $date);
    }

    if (!empty($options['on_days'])) {
        $options['on_days'] = explode(',', $options['on_days']);
        $w = date('N', strtotime($date));    
        while (!in_array($w, $options['on_days'])) {
            $date = date_i18n('Y-m-d', strtotime('+1 day', strtotime($date)));
            $w = date('N', strtotime($date));
        }
    }

    return $date;
}

function request_a_date_403_get_last_day($date) {
    $options = request_a_date_403_get_options();
    if ((!empty($options['max'])) and ($options['max'] > 0)) {
        $date = date_i18n('Y-m-d', strtotime('+'.$options['max'].' day', strtotime($date)));
    } else {
        $date = '';
    }
    
    if (has_filter('request_a_date_modify_last')) {
        $date = apply_filters('request_a_date_modify_last', $date);
    }
    
    return $date;
}

function request_a_date_403_check_ship() {

    $options = request_a_date_403_get_options();
    $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
    $shipping = $chosen_methods[0];
    
    $status = 0;
    $aviable = explode(',', $options['use_shipping']);
    if (in_array($shipping, $aviable)) {
        $status = 1;
    }
    $result = array(
        'status' => $status
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_request_a_date_403_check_ship', 'request_a_date_403_check_ship' );
add_action( 'wp_ajax_request_a_date_403_check_ship', 'request_a_date_403_check_ship' );

function request_a_date_403_show_date_select()
{
    $date = date('Y-m-d');
    if (isset($_REQUEST['date'])) {
        $date = sanitize_text_field($_REQUEST['date']);
    }

    $options = request_a_date_403_get_options();
    $options['disableds'] = str_replace(' ', '', $options['disableds']);
    $disabled_days = explode(',', $options['disableds']);
   
    $start_of_week = get_option( 'start_of_week' );
    $daylist = array();
    $days = array(
        __('Su', 'request-a-date'),
        __('Mo', 'request-a-date'),
        __('Tu', 'request-a-date'),
        __('We', 'request-a-date'),
        __('Th', 'request-a-date'),
        __('Fr', 'request-a-date'),
        __('Sa', 'request-a-date'));
    for ($i = $start_of_week; $i <= 6; $i++) {
    	$daylist[] = __($days[$i]);
    }
    for ($i = 0; $i < $start_of_week; $i++) {
    	$daylist[] = __($days[$i]);
    }
    $week = apply_filters('request_a_date_render_days_in_week', $daylist);    
    
    $days = array();
    $month = substr($date, 0, 7);
    $f = date('N', strtotime($month.'-01'));
    for ($i = 0; $i < ($f - $start_of_week); $i++) {
    	$days[] = apply_filters('request_a_date_render_empty_day', ''); 
        $col++;
    }
    $days_count = date('t', strtotime($month));
    
    $first = request_a_date_403_get_first_day();
    $last  = request_a_date_403_get_last_day($first);

    if (!empty($options['on_days'])) {
        $options['on_days'] = explode(',', $options['on_days']);
    } 
    
    for ($i = 1; $i <= $days_count; $i++) {    
        $class = array();
        if ($i < 10) {
            $date_index = $month.'-0'.$i;
        } else {
            $date_index = $month.'-'.$i;
        }
        if (($date_index >= $first) and (($date_index <= $last) or ($last == ''))) { 
            $is_disabled = false;
            
            if (!empty($options['on_days'])) {
                $w = date('N', strtotime($date));    
                while (in_array($w, $options['on_days'])) {
                    $date = date_i18n('Y-m-d', strtotime('+1 day', strtotime($date)));
                    $w = date('N', strtotime($date));
                }
            }

            if (!empty($options['on_days'])) {
                $f = date('N', strtotime($date_index));                
                if (!in_array($f, $options['on_days'])) {
                    $is_disabled = true;
                }
            }
            if (in_array($date_index, $disabled_days)) {
                $is_disabled = true;
            }
            
            if ($is_disabled) {
                $class[] = 'disabled';
            } else {
                $class[] = 'optional';
            }
        } else {
            $class[] = 'disabled';
        }
        
        $days[] = apply_filters('request_a_date_render_day', $i, $date_index, implode(' ', $class));
    }
    $days = implode('', $days);

    $prev_link = '';
    if ($month > date_i18n('Y-m')) {
        $prev_link = '<div class="request-a-date-prev-link">' . 
                     '<span onclick="request_a_date_403_show_month(\''.date_i18n('Y-m-d', strtotime('-1 month', strtotime($month.'-01'))).'\')" class="dashicons dashicons-arrow-left"></span>'.
                     '</div>';        
    } else {
        $prev_link = '<div class="request-a-date-prev-link">&nbsp;</div>';        
    }

    $next_link = '';
    if ($month < substr($last, 0, 7)) {
        $next_link = '<div class="request-a-date-next-link">' . 
                     '<span onclick="request_a_date_403_show_month(\''.date_i18n('Y-m-d', strtotime('+1 month', strtotime($month.'-01'))).'\')" class="dashicons dashicons-arrow-right"></span>'.
                     '</div>';        
    } else {
        $next_link = '<div class="request-a-date-next-link">&nbsp;</div>';        
    }
    
    $header = '<div class="request-a-date-header">'.
              $prev_link.
              $next_link.
              '<span class="year">'.date_i18n('Y', strtotime($date)).'.&nbsp;</span>'.
              '<span class="month">'.date_i18n('F', strtotime($date)).'</span>'.
              '</div>';
    
    $html = '<div id="request_a_date_calendar_select">'.$header.$week.$days.'</div>';
    
    $result = array(
        'status' => 1,
        'html'   => $html
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_request_a_date_403_show_date_select', 'request_a_date_403_show_date_select' );
add_action( 'wp_ajax_request_a_date_403_show_date_select', 'request_a_date_403_show_date_select' );

function request_a_date_403_get_formatted_date() {
    $date = date('Y-m-d');
    if (isset($_REQUEST['date'])) {
        $date = sanitize_text_field($_REQUEST['date']);
    }

    $options = request_a_date_403_get_options();
    $html = date_i18n($options['date_format'], strtotime($date));    

    $result = array(
        'status' => 1,
        'html'   => $html
    );
    echo json_encode($result);
    wp_die();

    
}
add_action( 'wp_ajax_nopriv_request_a_date_403_get_formatted_date', 'request_a_date_403_get_formatted_date' );
add_action( 'wp_ajax_request_a_date_403_get_formatted_date', 'request_a_date_403_get_formatted_date' );
