<?php
function request_a_date_403_render_days_in_week($days) {

    $html = array();
    foreach ($days as $day) {
        $html[] = '<div class="item week">'.$day.'</div>';
    }
    $html = implode('', $html) . 
            '<div class="separator">&nbsp;</div>';

    return $html;
}
add_filter( 'request_a_date_render_days_in_week', 'request_a_date_403_render_days_in_week', 10, 1 );

function request_a_date_403_render_empty_day($class) {
    $html = '<div class="item empty '.$class.'">&nbsp;</div>';
    return $html;
}
add_filter( 'request_a_date_render_empty_day', 'request_a_date_403_render_empty_day', 10, 1); 

function request_a_date_403_render_day($id, $index, $class) {
    $html = '<div class="item '.$class.'" data-date="'.$index.'">'.$id.'</div>';
    return $html;
}
add_filter( 'request_a_date_render_day', 'request_a_date_403_render_day', 10, 3); 

function request_a_date_403_render_button($script) {
    $html = '<button type="button" '.$script.' class="button">'.
            '<span class="dashicons dashicons-calendar-alt"></span>'.
            '</button>';
    return $html;
}
add_filter( 'request_a_date_render_button', 'request_a_date_403_render_button', 10, 1);

function request_a_date_403_render_in_table($title, $button, $description) {
    
    $html = '<th class="request-a-date-title">'.$title.'&nbsp;</th>'.
            '<td colspan="100">'.
                '<div id="request_a_date_calendar">'.$button.'</div>'.
                $description.
            '</td>';
    return $html;
} 
add_filter('request_a_date_render_in_table', 'request_a_date_403_render_in_table', 10, 3); 

function request_a_date_403_render_in_div($title, $button, $description) {
    
    $html = '<span class="request-a-date-title">'.$title.'</span>&nbsp;<div id="request_a_date_calendar">'.$button.'</div>'.
            $description;
    return $html;
} 
add_filter('request_a_date_render_in_div', 'request_a_date_403_render_in_div', 10, 3);


function request_a_date_403_render_in_thankyou($title, $date) {
    
    $html = $title .
			'<strong>'.$date.'</strong>';
    return $html;
} 
add_filter('request_a_date_render_in_thankyou', 'request_a_date_403_render_in_thankyou', 10, 2);

function request_a_date_403_render_in_email($title, $date) {
    
    $html = '<table cellspacing="0" cellpadding="6"><tbody>'.
            '<tr><th style="text-align:left;">'.$title.'</th>'.
    		'<td style="text-align:right;">'.$date.'</td></tr>'.
            '</tbody></table>';
                    
    echo $html;
} 
add_filter('request_a_date_render_in_email', 'request_a_date_403_render_in_email', 10, 2);

/*
function request_a_date_my_modify_first($date) {
    
    $date = date_i18n('Y-m-d', strtotime('+1 day', strtotime($date)));
    return $date;
} 
add_filter('request_a_date_modify_first', 'request_a_date_my_modify_first', 10, 1);

function request_a_date_my_modify_last($date) {
    
    $date = date_i18n('Y-m-d', strtotime('+1 day', strtotime($date)));
    return $date;
} 
add_filter('request_a_date_modify_last', 'request_a_date_my_modify_last', 10, 1);

function my_add_custom_days($days_count) {
    // In the $days_count variable, you get the number of days 
    // that the earliest selectable date must be due to the reorder.
    
    // These products are in the cart
    $items = WC()->cart->get_cart();
    $add = 0;
    
    foreach ($items as $item) {
        $terms = get_the_terms( $item['product_id'], 'product_cat' );
        foreach ($terms as $term) {
            // Check the category slug
            switch ($term->slug){ 
                // Here you can examine all categories of slugs
            	case 'other':
                    // You set it if not bigger. This is how you will get the highest value.
                    if ($add < 4) {
                        // You claim as much as you want.
                        $add = 4;
                    }
                    break;
            	default :
            }            
        }
    }
    if ($add != 0) {
        // If you want to increase it anyway
        // return $days_count + $add;
        
        // OR
        // If you want the later of the two dates
        if ($add > $days_count) {
            return $add;
        } else {
            return $days_count;
        }
                
    } else {
        return $days_count;
    }     
}
add_filter('request_a_date_add_custom_days', 'my_add_custom_days', 10, 1);

*/