<?php

    $options = request_a_date_403_get_options();
    
    if ($options['admin_column'] == 'yes') {
    
        function request_a_date_403_add_date_column($columns) {
            
            global $options;
            
            $reordered_columns = array();
        
            foreach( $columns as $key => $column){
                $reordered_columns[$key] = $column;
                if( $key ==  'order_status' ){
                    // Inserting after "Status" column
                    $reordered_columns['request-a-date'] = $options['title'];
                }
            }
            return $reordered_columns;
        }
        add_filter( 'manage_edit-shop_order_columns', 'request_a_date_403_add_date_column', 20 );
        
        $date_format = get_option('date_format');
        
        // Adding custom fields meta data for each new column (example)
        function request_a_date_403_date_column_content( $column, $post_id ) {
            
            global $date_format;
                
            switch ( $column )
            {
                case 'request-a-date' :
                    // Get custom post meta data
                    $date = get_post_meta( $post_id, 'request_a_date', true );
                    if(!empty($date)) {
                        echo date_i18n($date_format, strtotime($date));
                    } else {
                        echo '';
                    }
            }
        }
        add_action( 'manage_shop_order_posts_custom_column' , 'request_a_date_403_date_column_content', 20, 2 );

        function request_a_date_403_add_column_style() {
            $css = 'th.column-request-a-date,
                    td.column-request-a-date {
                    text-align: center;
                    width: 80px;
                    }';
            wp_register_style( 'request-a-date-admin', '');
            wp_add_inline_style( 'request-a-date-admin', $css );
            wp_enqueue_style( 'request-a-date-admin' );
        }
        add_action( 'admin_enqueue_scripts', 'request_a_date_403_add_column_style' );
        
    }
    
    if ($options['admin_info'] == 'yes') {
    
        // Szállítás napja a megrendelés részleteinél.
        function request_a_date_403_date_add_info($order){
            
            global $options, $date_format;
            
            $order_id = $order->get_id();
            $date = get_post_meta($order_id, 'request_a_date', true);
            if (!empty($date)) {
                $date = date_i18n($date_format, strtotime($date));
                echo '<strong>'.$options['title'].'</strong><br />' . $date;
            }
        }
        add_action( 'woocommerce_admin_order_data_after_shipping_address', 'request_a_date_403_date_add_info', 10, 1 );

    }