<?php

    $options = request_a_date_403_get_options();

    function request_a_date_403_show_date() {
        $options = request_a_date_403_get_options();
        
        $date = request_a_date_403_get_first_day();

        $date_text = date_i18n($options['date_format'], strtotime($date));
        
        $button = '<input type="text" disabled="disabled" class="request-a-date-info" style="width:auto;" value="'.$date_text.'" />'.
                  apply_filters('request_a_date_render_button', 'onclick="request_a_date_403_show_date_init();"');

        if ((isset($options['description'])) and (!empty($options['description']))) {
            $description = '<div class="request-a-date-description">'.$options['description'].'</div>';   
        } else {
            $description = '';
        }
                        
        if ($options['in_table'] == 'yes') {

            $html = apply_filters('request_a_date_render_in_table', $options['title'], $button, $description);    
            echo '<tr id="request_a_date_block">'.$html.'</tr>';

        } else {
            $html = apply_filters('request_a_date_render_in_div', $options['title'], $button, $description);    
            echo '<div id="request_a_date_block">'.$html.'</div>';
        }
        echo '<input type="hidden" name="request_a_date" id="request_a_date" value="'.$date.'" />';
    }
    
    if (!empty($options['woocommerce_checkout'])) {
        add_action( $options['woocommerce_checkout'], 'request_a_date_403_show_date');
    }


// Dátum mentése
// Save selected date
function request_a_date_403_save_date( $order_id ) {
    if (isset($_POST['request_a_date']) and ($_POST['request_a_date'] != '')) { 

        $options = request_a_date_403_get_options();
        $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
        $shipping = $chosen_methods[0];

        $aviable = explode(',', $options['use_shipping']);
        if (in_array($shipping, $aviable)) {

            $date = sanitize_text_field($_POST['request_a_date']);
            update_post_meta( $order_id, 'request_a_date', $date);
        }
    }
}
add_action('woocommerce_checkout_update_order_meta', 'request_a_date_403_save_date', 10, 1);

if ($options['add_thankyou'] == 'yes') {

    function request_a_date_403_add_thankyou($order_id) {
        
        global $options;
        
        if (!empty($order_id)) {

            $date = get_post_meta( $order_id, 'request_a_date', true );
            $date = date_i18n($options['date_format'], strtotime($date));

            $html = apply_filters('request_a_date_render_in_thankyou', $options['title'], $date);
            
            ?>
            <script type="text/javascript">
                document.addEventListener('DOMContentLoaded', function () {
                    var container = document.getElementsByClassName('woocommerce-thankyou-order-details');
                    var container = container[0];
                    
                    var item = document.createElement('li');
                    item.innerHTML = '<?php echo $html;?>';
                    // item.appendChild(document.createTextNode('<?php echo $html;?>'));
                    container.appendChild(item);
                });
            </script>
            <?php            
        }
    }
    add_action( 'woocommerce_thankyou', 'request_a_date_403_add_thankyou', 20, 1 );
}

if ($options['add_email'] == 'yes') {

    function request_a_date_403_add_email($order, $sent_to_admin, $plain_text, $email)
    {
        global $options;
        
        $order_id = $order->get_id();
        $date = get_post_meta($order_id, 'request_a_date', true);
        if (!empty($date)) {
            $date = date_i18n($options['date_format'], strtotime($date));
            $html = apply_filters('request_a_date_render_in_email', $options['title'], $date);
            echo $html;
        }
    }
    add_action('woocommerce_email_order_meta', 'request_a_date_403_add_email', 20, 4);
}